"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ReactMdeTextHelper_1 = require("../helpers/ReactMdeTextHelper");
var ReactMdeCommandHelper_1 = require("../helpers/ReactMdeCommandHelper");
exports.codeCommand = {
    icon: "code",
    tooltip: "Insert code",
    execute: function (text, selection) {
        if (text === void 0) { text = ""; }
        selection = ReactMdeTextHelper_1.selectCurrentWordIfCaretIsInsideOne(text, selection);
        if (text.slice(selection.start, selection.end).indexOf("\n") === -1) {
            // when there's no breaking line
            return ReactMdeCommandHelper_1.makeACommandThatInsertsBeforeAndAfter(text, selection, "`");
        }
        var textInsertion;
        // insert breaks before, if needed
        textInsertion = ReactMdeTextHelper_1.insertBreaksBeforeSoThatThereIsAnEmptyLineBefore(text, selection);
        text = textInsertion.newText;
        selection = textInsertion.newSelection;
        // inserts ```\n before
        textInsertion = ReactMdeTextHelper_1.insertBefore(text, "```\n", selection, false);
        text = textInsertion.newText;
        selection = textInsertion.newSelection;
        // inserts ```\n after
        textInsertion = ReactMdeTextHelper_1.insertAfter(text, "\n```", selection);
        text = textInsertion.newText;
        selection = textInsertion.newSelection;
        // insert breaks after, if needed
        textInsertion = ReactMdeTextHelper_1.insertBreaksAfterSoThatThereIsAnEmptyLineAfter(text, selection);
        text = textInsertion.newText;
        selection = textInsertion.newSelection;
        return { text: text, selection: selection };
    },
};
